<template>
  <div>
    <slot/>
  </div>
</template>

<script>
import {
  AToB as AToBAction,
  cityTour as cityTourAction
} from "@/actions/RoadtripAction";
import {provideDatas, provideMethods} from "@/libs/genProvider";
import {reactFromAPI, reactFromAPIPost} from "@/libs/reactFromAPI";
import {
  savePreferences as savePreferencesAction,
  saveRestaurantPreferences as saveRestaurantPreferencesAction,
  saveHostelPreferences as saveHostelPreferencesAction
} from "@/actions/TagsCategoriesAction";
import {
  saveRoadTrip as saveRoadTripAction
} from "@/actions/RoadTripsGestionAction";
import {
  updateRoadTripName as updateRoadTripNameAction
} from "@/actions/RoadTripsGestionAction";
import rand from "@/libs/rand";
import sleep from "@/libs/sleep";

export default {

  name: "RoadtripProvider",
  data: () => ({
    foundCitiesA: [],
    foundCitiesB: [],
    foundCitiesC: [],
    AToB: {
      violations: {
        name: [],
        cityA: [],
        cityB: [],
        from: [],
        to: [],
        nbDays: [],
        nbStepsByDay: [],
        minimumDurationByStep: [],
        interests: [],
        interestsRestaurant: [],
        categoriesHostel: [],
      },
      formValues: {
        from: null,
        to: null,
        name: "",
        nbDays: 4,
        nbStepsByDay: [['all', 2]],
        minimumDurationByStep: "02:00",
        interests: [],
        interestsRestaurant: [],
        categoriesHostel: [],
        cityA: "",
        cityB: "",
        codeCommuneA: null,
        codeCommuneB: null
      },
    },
    cityTour: {
      violations: {
        name: [],
        cityC: [],
        codeCommune: [],
        nbDays: [],
        nbStepsByDay: [],
        minimumDurationByStep: [],
        interests: [],
        interestsRestaurant: [],
        categoriesHostel: [],
      },
      formValues: {
        codeCommune: null,
        name: "",
        nbDays: 4,
        nbStepsByDay: [['all', 2]],
        minimumDurationByStep: "02:00",
        interests: [],
        interestsRestaurant: [],
        categoriesHostel: [],
        cityC: "",
      },
    },
    stepsAToB: null,
    stepsCityTour: null,
    currentStep: 0,
    chosens: null,
    foundRoadTrip: null,
    roadTripId: null,

    submittedValues: null,

    nameUpdatedByUser: false
  }),
  inject: ["createAlert","user","load"],
  provide() {
    const provider = {};

    provideDatas(provider, "roadtrip", this);
    provideMethods(provider, "roadtrip", this);

    return provider;
  },
  methods: {
    setNameUpdated() {
      this.nameUpdatedByUser = true;
    },
    resetCityPoints(c, values) {
      this["foundCities" + c] = [];
      if (c === "C") {
        values.codeCommune = null;
      } else {
        values[c === "A" ? "from" : "to"] = null;
        values['codeCommune'+c] = null;
      }
      if (!this.nameUpdatedByUser) {
        values.name = "";
      }
    },
    selectCity(city, values, c) {
      values["city" + c] = city.nom;
      if (c === "C") {
        values['codeCommune'] = city.code;
        if (!this.nameUpdatedByUser) {
          values.name = "City tour "+city.nom
        }
      } else {
        const [lng, lat] = city.centre.coordinates;
        values[c === "A" ? "from" : "to"] = lat + "," + lng;
        values['codeCommune'+c] = city.code;
        if (!this.nameUpdatedByUser) {
          values.name = "Road trip "+[
            [values.codeCommuneA,values.cityA],
            [values.codeCommuneB,values.cityB]
          ]
              .filter(([codeCommune]) => codeCommune !== null)
              .map(([,nameCommune]) => nameCommune)
              .join(" - ")
        }
      }
    },

    reSubmitRoadtrip() {
      if (this.submittedValues === null || this.foundRoadTrip === null)
        return;

      const {type} = this.foundRoadTrip;

      this['submit'+type[0].toUpperCase()+type.substring(1)](this.submittedValues);
    },

    submitAToB(values) {
      if (values.name.length > 50) {
        this.AToB.violations.name = ["Vous avez rentré un nom trop long"];
        return;
      }
      this.load.showLoading();
      return AToBAction(values).then(res =>
          reactFromAPI(
              res,
              this.AToB.violations,
              this.createAlert,
              "Road trip calculé avec succès",
              200,
              5000,
              {
                from: ["cityA"],
                to: ["cityB"]
              }
          ).then(async success => {
            this.load.hideLoading();
            if (!success) return;

            this.stepsAToB = [];
            this.roadTripId = null;

            this.submittedValues = values;

            savePreferencesAction(values.interests);
            saveRestaurantPreferencesAction(values.interestsRestaurant);
            saveHostelPreferencesAction(values.categoriesHostel);

            const foundRoadTrip = await res.json();


            foundRoadTrip.codeCommuneA = values.codeCommuneA;
            foundRoadTrip.codeCommuneB = values.codeCommuneB;
            foundRoadTrip.from = values.from.split(",").reduce((acc,v,index) => ({
              ...acc,
              [index === 0 ? "lat" : "lng"]: parseFloat(v.trim())
            }), {});
            foundRoadTrip.to = values.to.split(",").reduce((acc,v,index) => ({
              ...acc,
              [index === 0 ? "lat" : "lng"]: parseFloat(v.trim())
            }), {});
            foundRoadTrip.nbDays = parseInt(values.nbDays);
            foundRoadTrip.name = values.name.length > 0 ? values.name : "Sans nom";

            foundRoadTrip.type = "AToB";

            this.foundRoadTrip = foundRoadTrip;

            this.stepsAToB = this.generateStepsFromFoundRoadTrip(values);
            this.chosens = [];
            this.currentStep = 0;
            this.$router.push({name: "recherche-roadtrip-AtoB-step"});
          })
      )
    },
    submitCityTour(values) {
      if (values.name.length > 50) {
        this.cityTour.violations.name = ["Vous avez rentré un nom trop long"];
        return;
      }
      this.load.showLoading();
      cityTourAction(values).then(res =>
          reactFromAPI(
              res,
              this.cityTour.violations,
              this.createAlert,
              "City tour calculé avec succès",
              200,
              5000,
              {
                codeCommune: ["cityC"]
              }
          ).then(async success => {
            this.load.hideLoading();
            if (!success) return;

            this.stepsCityTour = [];
            this.roadTripId = null;

            this.submittedValues = values;

            savePreferencesAction(values.interests);
            saveRestaurantPreferencesAction(values.interestsRestaurant);
            saveHostelPreferencesAction(values.categoriesHostel);

            const foundRoadTrip = await res.json();

            foundRoadTrip.nbDays = parseInt(values.nbDays);
            foundRoadTrip.codeCommune = values.codeCommune;

            foundRoadTrip.name = values.name.length > 0 ? values.name : "Sans nom";

            foundRoadTrip.type = "cityTour";

            this.foundRoadTrip = foundRoadTrip;

            this.stepsCityTour = this.generateStepsFromFoundRoadTrip(values);

            this.chosens = [];

            this.$router.push({name: "recherche-roadtrip-CityTour-step"})
          })
      )
    },
    generateStepAToBInitialValue(step) {
      return {
        ...(step.restaurants.length > 0 ? {restaurant: 0} : {}),
        ...((step.hostels && step.hostels.length > 0) ? {hostel: 0} : {})
      }
    },
    generateStepCityTourInitialValues() {
      if (this.stepsCityTour === null)
        return {};
      return this.stepsCityTour.reduce((acc,step) => ({
        ...acc,
        ...((step.restaurants && step.restaurants.length > 0) ? {["restaurant_"+(step.nbDay??"all")]: 0} : {}),
        ...((step.hostels && step.hostels.length > 0) ? {["hostel_"+(step.nbDay??"all")]: 0}: {})
      }), {})
    },
    async submitStepAToB(values,step) {
      const chosen = {nbDay: step.nbDay};
      let randomlyChosen = false;
      if (values.restaurant === 0) {
        chosen.restaurant = step.restaurants[rand(0,step.restaurants.length-1)];
        values.restaurant = chosen.restaurant.id;
        randomlyChosen = true;
      } else if (values.restaurant) {
        chosen.restaurant = step.restaurants.find(({id}) => id === values.restaurant)
      }
      if (values.hostel === 0) {
        chosen.hostel = step.hostels[rand(0,step.hostels.length-1)]
        values.hostel = chosen.hostel.id;
        randomlyChosen = true;
      } else if (values.hostel) {
        chosen.hostel = step.hostels.find(({id}) => id === values.hostel)
      }

      if (randomlyChosen)
        await sleep(500);

      if (this.chosens.length > this.currentStep)
        this.chosens[this.currentStep] = chosen;
      else
        this.chosens.push(chosen);

      if (this.currentStep < this.stepsAToB.length-1)
        this.currentStep++;
      else
        this.applyChoicesToRoadTrip();
    },
    async submitStepCityTour(values) {
      let randomlyChosen = false;
      for (const step of this.stepsCityTour) {
        const chosen = {nbDay: step.nbDay};
        for (const fieldName of ["restaurant","hostel"]) {
          const fieldKey = fieldName+"_"+(step.nbDay??"all");
          if (values[fieldKey] === undefined)
            continue;
          const choices = step.nbDay !== undefined ?
              this.foundRoadTrip[fieldName + "Positions"][step.nbDay - 1].restaurants :
              this.foundRoadTrip.hostels
          let fieldValue;
          if (values[fieldKey] === 0) {
            randomlyChosen = true;
            fieldValue = choices[rand(0,choices.length-1)];
            values[fieldKey] = fieldValue.id
          } else {
            fieldValue = choices.find(({id}) => id === values[fieldKey]);
          }
          chosen[fieldName] = fieldValue;
        }
        this.chosens.push(chosen);
      }
      if (randomlyChosen)
        await sleep(500);
      this.applyChoicesToRoadTrip();
    },
    prevStepAToB() {
      this.currentStep--;
    },
    applyChoicesToRoadTrip() {
      for (let i=this.chosens.length-1;i>=0;i--) {
        const chosen = this.chosens[i];
        if (chosen.nbDay) {
          if (chosen.hostel) {
            const hostelPosition = this.foundRoadTrip.hostelPositions[chosen.nbDay-1].POIIndex;
            this.foundRoadTrip.road.splice(hostelPosition,0,chosen.hostel)
          }
          if (chosen.restaurant) {
            const restaurantPosition = this.foundRoadTrip.restaurantPositions[chosen.nbDay-1].POIIndex+1;
            this.foundRoadTrip.road.splice(restaurantPosition,0,chosen.restaurant)
          }
        } else if (chosen.hostel) {
          this.foundRoadTrip.hostel = chosen.hostel;
        }
      }

      this.foundRoadTrip.restaurantPositions = undefined;
      this.foundRoadTrip.hostelPositions = undefined;
      this.foundRoadTrip.hostels = undefined;
      this.$router.push({name: "recherche-roadtrip-result"})
    },
    generateStepsFromFoundRoadTrip(values) {
      const steps = [];
      if (this.foundRoadTrip.hostels)
        steps.push({
          hostels: this.foundRoadTrip.hostels
        });
      for (let i = 0; i < parseInt(values.nbDays); i++) {
        const step = {
          nbDay: i + 1,
          restaurants: this.foundRoadTrip.restaurantPositions[i].restaurants
        };
        if (this.foundRoadTrip.hostelPositions && this.foundRoadTrip.hostelPositions[i]) {
          step.hostels = this.foundRoadTrip.hostelPositions[i].hostels
        }
        steps.push(step);
      }
      return steps;
    },
    saveRoadTrip() {
      if (this.roadTripId) {
        updateRoadTripNameAction(this.roadTripId,this.foundRoadTrip.name)
            .then(res =>
              reactFromAPI(
                  res,
                  {},
                  this.createAlert,
                  "Sauvegarde réussie !",
                  200
              ).then(async success => {
                if (!success)
                  return;
                const {roadtrip: {name}} = await res.json();
                this.foundRoadTrip.name = name;
              })
            )
      } else {
        saveRoadTripAction({
          userId: this.user.session.id,
          roadtrip: {
            ...this.foundRoadTrip,
            contour: undefined
          }
        }).then(res =>
            reactFromAPIPost(
                res,
                {},
                this.createAlert,
                "Road trip sauvegardé avec succès !",
            ).then(async success => {
              if (!success) return;
              const {_id, roadtrip: {name}} = await res.json();
              this.roadTripId = _id;
              this.foundRoadTrip.name = name;
            })
        )
      }
    },
    reset() {
      this.chosens = null;
      this.stepsAToB = null;
      this.stepsCityTour = null;
      this.currentStep = null;
      this.nameUpdatedByUser = false;
      this.submittedValues = null;
    }
  }
};
</script>
